#include <utility>

class OnlyMove{
  public:

  OnlyMove()= default;

  OnlyMove& operator= (const OnlyMove&)= delete;
  OnlyMove (const OnlyMove&)= delete;

  OnlyMove& operator= (OnlyMove&&)= default;
  OnlyMove (OnlyMove&&) = default;
};

class OnlyOnStack {
  public:
    void* operator new(std::size_t)= delete;
};

class OnlyOnHeap{
  public:
    ~OnlyOnHeap()= delete;
};

void onlyDouble(double){}
template <typename T>
void onlyDouble(T)=delete;

int main(){

  OnlyMove onlyMove;
  OnlyMove onlyMove1(std::move(onlyMove));
  // OnlyMove onlyMove2(onlyMove1);

  OnlyOnStack onlyOnStack;
  // OnlyOnStack* onlyOnStack1= new OnlyOnStack;

  OnlyOnHeap* onlyOnHeap= new OnlyOnHeap;
  // OnlyOnHeap onlyOnHeap1;

  onlyDouble(3.14);
  // onlyDouble(2011);

}
